<?php
/*

PHP

RSS-parser v0.2-2022.06.20

Генерація стрічки новин. Тестова сторінка без кешу.
На виході - стрічка новин з вбудованим CSS і форматуванням.

Головна ціль - доставка легкого текстового контенту.

Перевіряється існування джерела новин, граббиться фавікон,
встановлюється кількість записів для відображення, та фільтруються
зайві стилі і помилки у фідах (підбирається в залежності від джерела).

Формується поточна дата. Теги з фіду обробляються лише при їх наявності.

*/

	// Вказуємо адресу стрічки RSS. Одну, на вибір.
	
	// $URL = "https://chtyvo.org.ua/feed/bookshq.rss";
	// $URL = "https://suspilne.media/rss/ukrnet.rss"; // full-text
	// $URL = "https://espreso.tv/rss";
	// $URL = "https://www.liga.net/news/photo/rss.xml"; // enclosure
	// $URL = "https://www.liga.net/news/all/rss.xml"; // enclosure
	// $URL = "https://www.5.ua/novyny/rss/";
	// $URL = "https://site.ua/rss-all.xml";
	// $URL = "http://k.img.com.ua/rss/ua/space.xml";
$URL = "http://k.img.com.ua/rss/ua/events.xml";
	// $URL = "http://k.img.com.ua/rss/ua/worldabus.xml";
	// $URL = "http://k.img.com.ua/rss/ua/world.xml";

	// Форматуємо поточну дату.
	// Дивись http://userguide.icu-project.org/formatparse/datetime
	$fmt = new IntlDateFormatter(
		'uk_Uk',
		IntlDateFormatter::FULL,
		IntlDateFormatter::FULL,
		'Europe/Kiev',
		IntlDateFormatter::GREGORIAN,
		'd MMMM, Y року'
	);
	$today = "Сьогодні ".$fmt->format(time());
?>
<!DOCTYPE HTML>
<html lang="uk">
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
		<title>RSS | Home</title>
		<meta name="description" content="Електронний архів документів і тестувальний майданчик для приватного користування.">
		<link rel="shortcut icon" href="favicon.png" type="image/x-icon">
	</head>
	<body style="font-family: Trebuchet MS;">
		<div style='padding: 20px 40px 20px 40px; color: DimGrey'>	
<?php
		// Перевірка існування файла з інформацією
		$urlHeaders = @get_headers($URL);
		// Якщо відповідь сервера на наявність коду: 200 - ОК, то читаємо контент
		if(strpos($urlHeaders[0], '200')) {
    		// Отримаємо favicon з сайта і формуємо шапку
			$favikon = "http://www.google.com/s2/favicons?domain=".$URL;
			echo $free = "			<div style='padding: 20px 0 30px 0; color: DimGrey;'><div style='display:inline;float:left;font-style:italic;'><strong>RSS новини</strong></div><div style='display:inline; float:right;font-style:italic;'>$today</div></div>";
			
			// Читаємо контент фіду
			$content = file_get_contents($URL);

			// Вказуємо кількість новин для виводу на сторінку
			$NUMITEMS = 15;
			$count = 0;
			 
			// Отримуємо XML стрічки з указаної адреси
			$element = new SimpleXMLElement($content);

			echo "<table style='border: 1px white; border-spacing: 0 10px;'>";

			foreach($element->channel->item as $entry) {
				
				// Фільтруємо сміття (цю частину треба доробити. Незакінчено.)
				$patterns = array();
				$patterns[0]  = '|(&amp;)|Uis';
				$patterns[1]  = '|(&nbsp;)|Uis';
				$patterns[2]  = '|(\[social).*(\])|Uis';		// видаляємо посилання на соцмережі
				$patterns[3]  = '|(<style>.*(</style>))|Uis';	// видаляємо всі загальні стилі
				$patterns[4]  = '|( />)|Uis';
				$patterns[5]  = '|( style=").*(")|Uis';			// видаляємо всі внутрішні стилі
				$patterns[6]  = '|(<span).*(>)|Uis';			// видаляємо метадані з <span title=...>, якщо вони є
				$patterns[7]  = '|(<span>)|Uis';				// видаляємо двома строками вкладені <span><span></span></span>
				$patterns[8]  = '|(</span>)|Uis';
				$patterns[9]  = '|(Додано твір <a).*(</a>)|Uis';
				$patterns[10] = '|(\(<a ).*(</a>\).)|Uis';		// видаляємо	посилання, розміщене в скобках
				$patterns[11] = '|(<img )|Uis';					// форматуємо зображення
				$patterns[12] = '|(<hr>)|Uis';					// видаляємо	лінії
				$patterns[13] = '|(<p> )|Uis';
				$patterns[14] = '|(<p>  )|Uis';				
				$patterns[15] = '|(<p></p>)|Ui';				// видаляємо порожні строки
				$patterns[16] = '|(<em>).*(</em>)|Uis';			// видаляємо коментарі
				$patterns[17] = '|(<!--).*(-->)|Uis';			// видаляємо коментарі				
				$patterns[18] = '|(	)|Uis';						// видаляємо	'tab'
				$patterns[19] = '|(  )|Uis';					// видаляємо 'подвійний пробіл'				
				$patterns[20] = '|(\n)|Uis';					// стискаємо інформацію

				$replacements = array();
				$replacements[0]  = '&';
				$replacements[1]  = ' ';
				$replacements[2]  = '';
				$replacements[3]  = '';
				$replacements[4]  = '>';			
				$replacements[5]  = '';
				$replacements[6]  = '';
				$replacements[7]  = '';
				$replacements[8]  = '';
				$replacements[9]  = '';
				$replacements[10] = '';
				$replacements[11] = '<img width="200" style="float:left; padding-right:20px; padding-bottom:20px;"';
				$replacements[12] = '';
				$replacements[13] = '<p>';
				$replacements[14] = '<p>';
				$replacements[15] = '';
				$replacements[16] = '';
				$replacements[17] = '';
				$replacements[18] = ' ';
				$replacements[19] = ' ';
				$replacements[20] = '';

				// Змінні для виводу на сторінку
				$date = new DateTime($entry->pubDate);
				$date = $date->format('Y-m-d H:i');

				$link = $entry->link;
				$guid = $entry->guid;

/* $test = '<enclosure length="9183" type="image/jpg" url="https://www.liga.net/images/general/2022/06/09/thumbnail-h-20220609092221-5370.jpg"/>';
if (preg_match('|url="(.*?)"|si', $enclosure, $arr)) $picture = "<img src='".$arr[1]."'>";
else $picture=''; */
				
				// Для тега <title>	якщо він є			
				if (!empty($entry->title)) {
					$title = "<p style='font-style: italic;'>".$entry->title."</p>";
					$title = preg_replace($patterns, $replacements, $title);
				} else {
					$title='';
				}

				// Для тега <category>	якщо він є			
				if (!empty($entry->category)) {
					$category = "<p style='font-style: italic;'>".$entry->category."</p>";
					$category = preg_replace($patterns, $replacements, $category);
				} else {
					$category='';
				}

				// Для тега <description>	якщо він є
				if (!empty($entry->description)) {
					$description = "<p>".$entry->description."</p>";
					$description = preg_replace($patterns, $replacements, $description);
				} else {
					$description='';
				}

				// Для тега <fulltext>	якщо він є
				if (!empty($entry->fulltext)) {
					$fulltext = "<p>".$entry->fulltext."</p>";
					$fulltext = preg_replace($patterns, $replacements, $fulltext);
				} else {
					$fulltext='';
				}

				// Для тега <content:encoded>	якщо він є
				if ($e_content = $entry->children("content", true)) {
					$e_encoded = "<p>".(string)$e_content->encoded."</p>";
					$e_encoded = preg_replace($patterns, $replacements, $e_encoded);
				} else {
					$e_encoded='';
				}

				echo "<tr style='background:#FFFFE0'><td><div style='margin: 0px 60px 30px 60px;'><div style='margin:20px 0 20px 0'><div style='color:tomato;font-style:italic;display:inline;float:left;'>$date</div><div style='display:inline;float:right;'><img src='$favikon'></div><div style='clear:both;'>$category</div><a style='text-decoration:none;' href=$link title='Перейти на сайт'>$title</a></div>$e_encoded $description $fulltext</div></td></tr>";

				// Виходимо з циклу, коли досягнута вказана кількість новин
				if (++$count >= $NUMITEMS) break;
			}
			echo "</table>\n";
			
				// Якщо сайт недоступний, то виводимо повідомлення і припиняємо роботу скрипта
			} else {
				echo "<center><p>Інформація поки недоступна з цього ресурсу.</p><p>Можливо, що на сервері проводяться технічні роботи. Таке буває.</p><p>Завітайте пізніше, будь ласка!</p></center>";
				exit;
			}
		?>
		</div>
	</body>
</html>